program OpenArch;

{%ToDo 'OpenArch.todo'}

uses
  Windows,
  Messages,
  CommCtrl,
  ShlObj,
  ShellAPI,
  ActiveX,
  Classes,
  SysUtils,
  CommDlg,
  Shlwapi,
  ZLib,
  AboutUnit,
  UnRAR,
  Archives,
  SystemGlobal,
  CDialogs;

{$R RESOURCE.RES}
{$R WINDOWSXP.RES}

const
  COLUMN_NONE     = -1;
  COLUMN_NAME     = 0;
  COLUMN_TYPE     = 1;
  COLUMN_MODIFIED = 2;
  COLUMN_SIZE     = 3;
  COLUMN_RATIO    = 4;
  COLUMN_PACKED   = 5;
  COLUMN_CRC32    = 6;
  COLUMN_ATTR     = 7;
  COLUMN_PATH     = 8;

var
  hwndRB,
  hwndTB,
  hwndSB,
  hwndLV,
  hwndTT,
  hwndHC: HWND;
  g_hImgListTool,
  ImageListLarge,
  ImageListSmall,
  ImageListHeader: HIMAGELIST;
  Archive: TArchiveFile;
  ProjectName: string;
  ProjectActive: Boolean = False;
  FolderIndex: Integer;
  SortColumn: Integer = COLUMN_NAME;
  //SortDirection: TSortDirections;
  SortAscending: Boolean = True;
  hcrWait: HCURSOR;
  hcrCurrent: HCURSOR;
  g_dwSelected: DWORD = 0;
  g_dwTotal: DWORD = 0;
  g_hfTipCaption: HFONT = 0;
  g_bToolTipActive: Boolean = False;
  g_strTime: string;

const
  IDC_TIMER = 1000;
  
const
  IDM_OPEN        = 40001;
  IDM_EXTRACT     = 40002;
  IDM_CLOSE       = 40003;
  IDM_EXIT        = 40004;

  IDM_LARGEICONS  = 40005;
  IDM_SMALLICONS  = 40006;
  IDM_LISTVIEW    = 40007;
  IDM_REPORTVIEW  = 40008;

  IDM_BYNAME      = 40010;
  IDM_BYTYPE      = 40011;
  IDM_BYMODIFIED  = 40012;
  IDM_BYSIZE      = 40013;
  IDM_BYRATIO     = 40014;
  IDM_BYPACKED    = 40015;
  IDM_BYCRC32     = 40016;
  IDM_BYATTR      = 40017;
  IDM_BYPATH      = 40018;

  IDM_ABOUT       = 40019;

const
  CM_ADDITEMEVENT     = WM_USER + 1;
  CM_EXTRACTITEMEVENT = WM_USER + 2;
  
var
  Accel: HACCEL;

type
  TEventNotify = class(TObject)
  private
    FArchive: TArchiveFile;
  protected

  public
    constructor Create(Archive: TArchiveFile);
    destructor Destroy; override;
    procedure AddItemEvent(Sender: TCustomArchiveFile; Item: TArchiveFileItem);
    procedure ExtractItemEvent(Sender: TCustomArchiveFile; Item: TArchiveFileItem);
  end;

  TArchiveProject = class(TObject)
  private
    FActive: Boolean;
    FArchive: TArchiveFile;
    FArchiveName: string;
    //FArchiveType: Integer;
  protected
    procedure SetActive(Value: Boolean);
  public
    constructor Create;
    destructor Destroy; override;
    procedure Open(const ArchiveName: string);
    procedure Close;
    procedure AddItemEvent(Sender: TCustomArchiveFile; Item: TArchiveFileItem);
    procedure ExtractItemEvent(Sender: TCustomArchiveFile; Item: TArchiveFileItem);
    property ArchiveName: string read FArchiveName;
    property Archive: TArchiveFile read FArchive;
    property Active: Boolean read FActive write SetActive;
  end;

var
  EventNotify: TEventNotify;

function ListViewInsertColumn(Wnd: HWND; const Text: string; Width: Integer;
  aSubItem: Integer; aMask: UINT; aFmt: Integer; iCol: Integer): Integer;
var
  Column: LV_COLUMN;
begin
  FillChar(Column, SizeOf(LV_COLUMN), 0);
  with Column do
  begin
    mask := aMask;
    fmt := aFmt;
    iSubItem := aSubItem;
    pszText := PChar(Text);
    cx := Width;
  end;
  Result := ListView_InsertColumn(Wnd, iCol, Column);
end;

procedure InitListViewControl(hLVWnd: HWND);
begin
  ListViewInsertColumn(hLVWnd, 'Name', 120, 0,
    LVCF_FMT or LVCF_WIDTH or LVCF_TEXT or LVCF_SUBITEM, LVCFMT_LEFT, 0);
  ListViewInsertColumn(hLVWnd, 'Type', 140, 0,
    LVCF_FMT or LVCF_WIDTH or LVCF_TEXT or LVCF_SUBITEM, LVCFMT_LEFT, 1);
  ListViewInsertColumn(hLVWnd, 'Modified', 100, 0,
    LVCF_FMT or LVCF_WIDTH or LVCF_TEXT or LVCF_SUBITEM, LVCFMT_LEFT, 2);
  ListViewInsertColumn(hLVWnd, 'Size', 60, 0,
    LVCF_FMT or LVCF_WIDTH or LVCF_TEXT or LVCF_SUBITEM, LVCFMT_RIGHT, 3);
  ListViewInsertColumn(hLVWnd, 'Ratio', 100, 0,
    LVCF_FMT or LVCF_WIDTH or LVCF_TEXT or LVCF_SUBITEM, LVCFMT_RIGHT, 4);
  ListViewInsertColumn(hLVWnd, 'Packed', 60, 0,
    LVCF_FMT or LVCF_WIDTH or LVCF_TEXT or LVCF_SUBITEM, LVCFMT_RIGHT, 5);
  ListViewInsertColumn(hLVWnd, 'CRC', 0, 0,
    LVCF_FMT or LVCF_WIDTH or LVCF_TEXT or LVCF_SUBITEM, LVCFMT_LEFT, 6);
  ListViewInsertColumn(hLVWnd, 'Attributes', 0, 0,
    LVCF_FMT or LVCF_WIDTH or LVCF_TEXT or LVCF_SUBITEM, LVCFMT_LEFT, 7);
  ListViewInsertColumn(hLVWnd, 'Path', 150, 0,
    LVCF_FMT or LVCF_WIDTH or LVCF_TEXT or LVCF_SUBITEM, LVCFMT_LEFT, 8);
end;

procedure SetViewStyle(hWndListView: HWND; dwView: DWORD);
var
  dwStyle: DWORD;
begin
  // Get the current window style.
  dwStyle := GetWindowLong(hWndListView, GWL_STYLE);
  // Only set the window style if the view bits have changed.
  if ((dwStyle and LVS_TYPEMASK) <> dwView) then
    SetWindowLong(hWndListView, GWL_STYLE,
      (dwStyle and not LVS_TYPEMASK) or dwView);
end;

{ InitListView }
function InitListView(hwndParent: HWND): HWND;
{var
  Style: Integer;}
begin

  Result := CreateWindowEx(WS_EX_CLIENTEDGE,
    WC_LISTVIEW,
    nil,
    WS_CHILD or WS_VISIBLE or LVS_REPORT or LVS_OWNERDATA,
    0, 0, 0, 0, hwndParent, IDC_LISTVIEW, SysInit.HInstance, nil);

  ListView_SetExtendedListViewStyle(Result,
    LVS_EX_INFOTIP or
    LVS_EX_FULLROWSELECT or
    LVS_EX_HEADERDRAGDROP or
    LVS_EX_DOUBLEBUFFER // aradigin bu parametrede sakli!
    );

  //ListView_SetCallbackMask( Result, LVIS_SELECTED );// or LVIS_FOCUSED );

end;

function CreateRebarControl(hwndParent: HWND): HWND;
var
  rbi: TREBARINFO;
  icex: TINITCOMMONCONTROLSEX;
begin

  icex.dwSize := sizeof(TINITCOMMONCONTROLSEX);
  icex.dwICC  := ICC_COOL_CLASSES or ICC_BAR_CLASSES;
  InitCommonControlsEx(icex);

  Result := CreateWindowEx(WS_EX_TOOLWINDOW,
    REBARCLASSNAME,
    nil,
    WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or
    WS_CLIPCHILDREN or RBS_VARHEIGHT or CCS_NODIVIDER or
    CCS_NOPARENTALIGN or RBS_BANDBORDERS or RBS_DBLCLKTOGGLE or RBS_AUTOSIZE,
    0, 0, 0, 0,
    hwndParent,
    IDC_REBAR,
    SysInit.hInstance,
    nil);

  rbi.cbSize := sizeof(TREBARINFO);
  rbi.fMask  := 0;
  rbi.himl   := HIMAGELIST(nil);
  SendMessage(Result, RB_SETBARINFO, 0, LPARAM(@rbi));

end;

function InsertBandControl(hwndRB, hwndControl: HWND; Text: PChar; cyMin, cx: Integer): BOOL;
var
  rbBand: TREBARBANDINFO;
begin

  Result := TRUE;

  FillChar(rbBand, SizeOf(TREBARBANDINFO), 0);
  rbBand.cbSize := SizeOf(TREBARBANDINFO);
  rbBand.fMask  := RBBIM_TEXT or
                   RBBIM_STYLE or RBBIM_CHILD or RBBIM_CHILDSIZE or
                   RBBIM_SIZE;
  rbBand.fStyle := RBBS_CHILDEDGE or RBBS_BREAK;
  rbBand.lpText     := Text;
  rbBand.hwndChild  := hwndControl;
  rbBand.cxMinChild := 0;
  rbBand.cyMinChild := cyMin;
  rbBand.cx         := cx;

  SendMessage(hwndRB, RB_INSERTBAND, WPARAM(-1), LPARAM(@rbBand));

end;

function CreateToolbarCtrlEx(hwndParent: HWND): HWND;
var
  Index: Integer;
const
  sText = '&Open'#0'&Extract...'#0'&Exit'#0#0;
const
  MAX_BUTTON = 2;
  Bitmaps: array[0..MAX_BUTTON-1] of Integer = (0, 1);
var
  ToolButtons: array[0..MAX_BUTTON-1] of TTBBUTTON;
begin

  FillChar(ToolButtons, SizeOf(ToolButtons), 0);

  for Index := 0 to MAX_BUTTON-1 do
    with ToolButtons[Index] do
    begin
      iBitmap := Bitmaps[Index];
      idCommand := IDM_OPEN + Index;
      fsState := TBSTATE_ENABLED;
      fsStyle := TBSTYLE_BUTTON;
      iString := Index;
    end;

  Result := CreateToolBarEx(
    hwndParent,
    WS_CHILD or WS_CLIPSIBLINGS or WS_VISIBLE or
    WS_CLIPCHILDREN or TBSTYLE_FLAT or
    TBSTYLE_TOOLTIPS or TBSTYLE_WRAPABLE or TBSTYLE_LIST or
    CCS_NORESIZE,
    IDC_TOOLBAR,
    MAX_BUTTON,
    0,
    0,
    @ToolButtons,
    MAX_BUTTON,
    0, 0,
    32, 32,
    SizeOf(TTBBUTTON)
  );
  SendMessage(Result, TB_ADDSTRING, 0, Integer(PChar(sText)));
  SendMessage(Result, TB_AUTOSIZE, 0, 0);
end;

{ InitStatusBar }
function InitStatusBar(Wnd: HWND): HWND;
var
  Style: Integer;
  iParts: array[0..2] of Integer;
begin

  Result := CreateWindowEx(0,
    STATUSCLASSNAME,
    nil,
    WS_CHILD or WS_VISIBLE or SBARS_SIZEGRIP,
    0, 0, 0, 0, Wnd, 0, hInstance, nil);

  iParts[0]  := 200;
  iParts[1]  := 357;
  iParts[2]  := -1;
  SendMessage(Result, SB_SETPARTS, 3, Integer(@iParts));

  Style := GetClassLong(Result, GCL_STYLE);
  Style := Style and not (CS_HREDRAW or CS_VREDRAW);
  SetClassLong(Result, GCL_STYLE, Style);

end;

procedure CloseProject(Wnd: HWND);
var
  strText: string;
begin

  if Assigned(Archive) then
  begin
    if Assigned(EventNotify) then
      FreeAndNil(EventNotify);
    Archive.Close;
    //FreeAndNil(Archive);
  end;

  g_dwSelected := 0;
  g_dwTotal := 0;

  ListView_DeleteAllItems(hwndLV);

  SetWindowText( Wnd, PChar(szCaption) );

  strText := 'No Files Selected';
  SendMessage(hwndSB, SB_SETTEXT, 0, LongInt(PChar(strText)));
  strText := '';
  SendMessage(hwndSB, SB_SETTEXT, 2, LongInt(PChar(strText)));

  SendMessage(hwndSB, SB_SETTEXT, 1, LongInt(PChar('No Archive')));

end;

function CompareInt(A, B: Integer): Integer;
begin
  if A > B then Result := 1
  else if A < B then Result := -1
  else Result := 0;
end;

function CompareWord(A, B: LongWord): Integer;
begin
  if A > B then Result := 1
  else if A < B then Result := -1
  else Result := 0;
end;

function CompareCRC32(File1, File2: TArchiveFileItem): Integer;
begin
  Result := CompareWord(File1.CRC32, File2.CRC32);
end;

function CompareDateTime(File1, File2: TArchiveFileItem): Integer;
begin
  Result := CompareInt(File1.DateTime, File2.DateTime);
end;

function CompareSize(File1, File2: TArchiveFileItem): Integer;
begin
  Result := CompareInt(File1.Size, File2.Size);
end;

function ComparePacked(File1, File2: TArchiveFileItem): Integer;
begin
  Result := CompareInt(File1.PackedSize, File2.PackedSize);
end;

function CompareRatio(File1, File2: TArchiveFileItem): Integer;
begin
  Result := CompareInt(File1.Ratio, File2.Ratio);
end;

function ListSortCompare(Item1, Item2: Pointer): Integer;
var
  File1, File2: TArchiveFileItem;
begin

  File1 := TArchiveFileItem(Item1);
  File2 := TArchiveFileItem(Item2);

  case SortColumn of
    COLUMN_NAME:
      Result := StrIComp(PChar(File1.FileName), PChar(File2.FileName));
    COLUMN_TYPE:
      Result := StrIComp(PChar(File1.FileType), PChar(File2.FileType));
    COLUMN_MODIFIED:
      Result := CompareDateTime(File1, File2);
    COLUMN_SIZE:
      Result := CompareSize(File1, File2);
    COLUMN_RATIO:
      Result := CompareRatio(File1, File2);
    COLUMN_PACKED:
      Result := ComparePacked(File1, File2);
    COLUMN_ATTR:
      Result := StrIComp(PChar(File1.AttributeAsString), PChar(File2.AttributeAsString));
    COLUMN_CRC32:
      Result := CompareCRC32(File1, File2);
    COLUMN_PATH:
      Result := StrIComp(PChar(File1.Path), PChar(File2.Path));
    else
      Result := StrIComp(PChar(File1.FileName), PChar(File2.FileName));
  end;

  if (SortColumn <> COLUMN_NAME) and (Result = 0) then
    Result := StrIComp(PChar(File1.FileName), PChar(File2.FileName));

  if not SortAscending then
    Result := -Result;

end;

const
  KiloByte = 1024;
  MegaByte = KiloByte * 1024;
  GigaByte = MegaByte * 1024;

function FormatByteSize(ByteSize: LongWord): string;
begin
  if ByteSize > KiloByte then
    Result := Format('%.2n KB', [ByteSize/(KiloByte)])
  else if ByteSize > MegaByte then
    Result := Format('%.2n MB', [ByteSize/(MegaByte)])
  else if ByteSize > GigaByte then
    Result := Format('%.2n GB', [ByteSize/(GigaByte)])
  else Result := Format('%.0n bytes', [ByteSize/1]);
end;

function OpenProject(Wnd: HWND; const FileName: string): BOOL;
var
  TotalFile: LongWord;
  TotalSize: LongWord;
  TotalPacked: LongWord;
  Text: string;
begin

  CloseProject(Wnd);

  if Assigned(EventNotify) then
    FreeAndNil(EventNotify);

  if Assigned(Archive) then
  begin
    FreeAndNil(Archive);
  end;

  Text := ExtractFileExt(FileName);
  if StrIComp(PChar(Text), '.zip') = 0 then
    Archive := TZipArchiveFile.Create
  else if StrIComp(PChar(Text), '.rar') = 0 then
    Archive := TRarArchiveFile.Create
  else if StrIComp(PChar(Text), '.cab') = 0 then
    Archive := TCabArchiveFile.Create
  else Archive := TZipArchiveFile.Create;

  EventNotify := TEventNotify.Create(Archive);

  if Assigned(Archive) then
  begin
    Archive.ArchiveName := FileName;
    Archive.Open;
    Archive.FileList.Sort(@ListSortCompare);
  end;

  TotalFile := Archive.Count;

  TotalSize := Archive.Size;

  TotalPacked := Archive.PackedSize;

  Text := Format('Total %d files. Size %s. Packed %s', [TotalFile,
    FormatByteSize(TotalSize), FormatByteSize(TotalPacked)]);

  SendMessage(hwndSB, SB_SETTEXT, 2, LongInt(PChar(Text)));

  g_dwSelected := 0;
  g_dwTotal := 0;
  Text := Format('Selected %d files, %s', [g_dwSelected, FormatByteSize(g_dwTotal)]);

  SendMessage(hwndSB, SB_SETTEXT, 0, LongInt(PChar(Text)));

  ListView_SetItemCount(hwndLV, Archive.Count);

  ListView_Arrange(hwndLV, LVA_DEFAULT);

  Result := True;

  SetWindowText( Wnd, PChar(szCaption + '-' + ProjectName) );

  SendMessage(hwndSB, SB_SETTEXT, 1,
    LongInt(PChar('Archive: ' + ExtractFileName(ProjectName))));

end;

function CreateProject: BOOL;
begin
  Result := True;
  if not Assigned(Archive) then
  begin
    Archive := TZipArchiveFile.Create;
    if not Assigned(EventNotify) then
      EventNotify := TEventNotify.Create(Archive);
  end;
end;

procedure DestroyProject(Wnd: HWND);
begin
  CloseProject(Wnd);
end;

function IsFolder(ArchiveFile: TArchiveFileItem): Boolean;
begin
  Result := (ArchiveFile.Attribute and FILE_ATTRIBUTE_DIRECTORY) <> 0;
end;

const
  IDC_TOOLTIP    = 2001;

function CreateToolTipControl(hwndParent: HWND; hwndLV: HWND): HWND;
var
  tti: TTOOLINFO;
  hWndTT: HWND;
begin

  Result := CreateWindowEx(WS_EX_LAYERED or WS_EX_TOOLWINDOW,
    TOOLTIPS_CLASS,
    nil,
    WS_POPUP or TTS_NOPREFIX or TTS_ALWAYSTIP,// or TTS_BALLOON,
    0, 0,
    0, 0,
    hWndParent, 0,
    SysInit.HInstance,
    nil);

  SetWindowPos( Result, HWND_TOPMOST, 0, 0, 0, 0,
    SWP_NOMOVE or SWP_NOSIZE or SWP_NOACTIVATE );

  FillChar( tti, SizeOf(TTOOLINFO), 0 );
  tti.cbSize := SizeOf(TTOOLINFO);
  tti.uFlags := TTF_IDISHWND or TTF_SUBCLASS;
  tti.hwnd   := hwndParent;
  tti.uId    := hwndLV;
  tti.hinst  := 0;
  tti.lpszText  := LPSTR_TEXTCALLBACK;
  GetClientRect( hWndLV, tti.rect );

  SendMessage( Result, TTM_ADDTOOL, 0, LongInt(@tti) );
  SendMessage( Result, TTM_SETDELAYTIME, TTDT_AUTOMATIC, MakeLong(1500, 0) );

  hWndTT := ListView_GetToolTips( hWndLV );
  FillChar( tti, SizeOf(TTOOLINFO), 0 );
  tti.cbSize := SizeOf(TTOOLINFO);
  tti.hwnd   := hwndLV;//hwndParent;//
  tti.uId    := 0;//IDC_LISTVIEW;//hwndLV;
  if SendMessage( hWndTT, TTM_GETTOOLINFO, 0, LongInt(@tti) ) <> 0 then
  begin
    if tti.uFlags and TTF_SUBCLASS <> 0 then;
    //MessageBeep(MB_OK);
  end;

  ListView_SetToolTips( hWndLV, Result );

end;

const
  HDF_SORTUP   = $0400;
  HDF_SORTDOWN = $0200;

function InitHeaderControl(hwndLv: HWND): HWND;
var
  hdi: _HD_ITEM;
begin
  Result := ListView_GetHeader( hwndLV );
  {
  Header_SetImageList( Result, ImageListHeader );
  FillChar( hdi, SizeOf(hdi), 0 );
  hdi.Mask := HDI_FORMAT or HDI_IMAGE;
  Header_GetItem( Result, 0, hdi );
  hdi.Mask := hdi.Mask or HDI_IMAGE;
  hdi.iImage := 1;
  hdi.fmt := hdi.fmt or HDF_BITMAP_ON_RIGHT or HDF_IMAGE;
  Header_SetItem( Result, 0, hdi );
  }
end;

procedure ChangeSortBitmap(Column: Integer; SortAscending: Boolean);
var
  hdi: _HD_ITEM;
  hwndHD: HWND;
begin
  hwndHD := ListView_GetHeader( hwndLV );
  FillChar( hdi, SizeOf(hdi), 0 );
  hdi.Mask := HDI_FORMAT;
  Header_GetItem( hwndHD, Column, hdi );

   // For Window XP Style
  if SortAscending then hdi.fmt := hdi.fmt or HDF_SORTUP
  else hdi.fmt := hdi.fmt or HDF_SORTDOWN;
  Header_SetItem( hwndHD, Column, hdi );

  {
  FillChar( hdi, SizeOf(hdi), 0 );
  hdi.Mask := HDI_FORMAT or HDI_IMAGE;
  Header_GetItem( hwndHD, Column, hdi );
  if SortAscending then hdi.iImage := 0
  else hdi.iImage := 1;
  hdi.fmt := hdi.fmt or HDF_BITMAP_ON_RIGHT or HDF_IMAGE;
  Header_SetItem( hwndHD, Column, hdi );
  }
end;

procedure ClearSortBitmap(Column: Integer);
var
  hdi: _HD_ITEM;
  hwndHD: HWND;
begin
  hwndHD := ListView_GetHeader( hwndLV );
  FillChar( hdi, SizeOf(hdi), 0 );
  hdi.Mask := HDI_FORMAT;
  Header_GetItem( hwndHD, Column, hdi );
  // For Windows XP Style
  hdi.fmt := hdi.fmt and ( not ( HDF_SORTUP or HDF_SORTDOWN ) );
  //hdi.fmt := hdi.fmt and ( not ( HDF_BITMAP_ON_RIGHT or HDF_IMAGE ) );
  Header_SetItem( hwndHD, Column, hdi );
end;

{ OnCreate }
function OnCreate(Wnd: HWND; uMsg: UINT; wParam: LongInt; lParam: LongInt): LRESULT;
var
  hiTool: HICON;
  FileInfo: TSHFILEINFO;
  hbmUpDown: HBITMAP;
  ncm: NONCLIENTMETRICS;
  lf: LOGFONT;
  dc: HDC;
begin

  Result := 0;

  hbmUpDown := LoadBitmap( SysInit.HInstance, MakeIntResource(103) );

  hcrWait := LoadCursor(0, IDC_WAIT);

  dc := GetDC(HWND_DESKTOP);
  ncm.cbSize := SizeOf( ncm );
  SystemParametersInfo( SPI_GETNONCLIENTMETRICS, 0, @ncm, 0 );
  System.Move( ncm.lfMessageFont, lf, SizeOf( LOGFONT ) );
  lf.lfWeight := FW_BOLD;
  lstrcpy( lf.lfFaceName, 'Tahoma' );
  //lstrcpy( lf.lfFaceName, 'Arial' );
  lf.lfCharSet := TURKISH_CHARSET;
  lf.lfHeight := - MulDiv( GetDeviceCaps( dc, LOGPIXELSY ), 8, 72 );
  g_hfTipCaption := CreateFontIndirect( lf );
  ReleaseDC(HWND_DESKTOP, dc);

  CreateProject();

  FillChar(FileInfo, SizeOf(FileInfo), 0);

  g_hImgListTool := ImageList_Create( GetSystemMetrics(SM_CXICON),
    GetSystemMetrics(SM_CYICON), ILC_COLOR32 or ILC_MASK, 5, 5 );

  ImageListHeader := ImageList_Create( GetSystemMetrics(SM_CXSMICON),
    GetSystemMetrics(SM_CYSMICON), ILC_COLOR32 or ILC_MASK, 2, 2 );

  ImageList_AddMasked( ImageListHeader, hbmUpDown, RGB(192, 192, 192) );

  DeleteObject( hbmUpDown );

  hiTool := LoadImage( SysInit.HInstance, MakeIntResource( 102 ), //267
    IMAGE_ICON, GetSystemMetrics(SM_CXICON),
    GetSystemMetrics(SM_CYICON), LR_DEFAULTCOLOR );
  if hiTool <> 0 then begin
    ImageList_AddIcon( g_hImgListTool, hiTool );
    DestroyIcon( hiTool );
  end;

  hiTool := LoadImage( SysInit.HInstance, MakeIntResource( 103 ),
    IMAGE_ICON, GetSystemMetrics(SM_CXICON),
    GetSystemMetrics(SM_CYICON), LR_DEFAULTCOLOR );
  if hiTool <> 0 then begin
    ImageList_AddIcon( g_hImgListTool, hiTool );
    DestroyIcon( hiTool );
  end;
  {
  hiTool := LoadImage( SysInit.HInstance, MakeIntResource( 105 ),
    IMAGE_ICON, GetSystemMetrics(SM_CXICON),
    GetSystemMetrics(SM_CYICON), LR_DEFAULTCOLOR );
  if hiTool <> 0 then begin
    ImageList_AddIcon( g_hImgListTool, hiTool );
    DestroyIcon( hiTool );
  end;
  }
  ImageListLarge := SHGetFileInfo('abc.dsp',
    0,
    FileInfo,
    SizeOf(FileInfo),
    SHGFI_SYSICONINDEX or SHGFI_LARGEICON or
    SHGFI_USEFILEATTRIBUTES or SHGFI_TYPENAME);

  ImageListSmall := SHGetFileInfo('abc.dsp',
    0,
    FileInfo,
    SizeOf(FileInfo),
    SHGFI_SYSICONINDEX or SHGFI_SMALLICON or
    SHGFI_USEFILEATTRIBUTES or SHGFI_TYPENAME);

  SHGetFileInfo('C:\WINDOWS',
    0,
    FileInfo,
    SizeOf(FileInfo),
    SHGFI_SYSICONINDEX or SHGFI_LARGEICON or SHGFI_TYPENAME);

  FolderIndex := FileInfo.iIcon;

  hwndRB := CreateRebarControl(Wnd);

  hwndSB := InitStatusBar(Wnd);

  hwndTB := CreateToolbarCtrlEx(Wnd);

  SendMessage(hwndTB, TB_SETIMAGELIST, 0, g_hImgListTool);

  InsertBandControl(hwndRB, hwndTB, '', 40, 75);

  hwndLV := InitListView(Wnd);

  InitListViewControl(hwndLV);

  ListView_SetImageList(hwndLV, ImageListLarge, LVSIL_NORMAL);

  ListView_SetImageList(hwndLV, ImageListSmall, LVSIL_SMALL);

  g_strTime := TimeToStr(Time);

  hwndTT := CreateToolTipControl( Wnd, hwndLV );

  hwndHC := InitHeaderControl( hwndLV );

  ChangeSortBitmap( SortColumn, SortAscending );

  //hwndTT := ListView_GetToolTips( hwndLV );

end;

{ OnDestroy }
function OnDestroy(Wnd: HWND; uMsg: UINT; wParam: LongInt; lParam: LongInt): LRESULT;
begin
  DestroyCursor(hcrWait);
  Result := 0;
  ImageList_Destroy(g_hImgListTool);
  ImageList_Destroy(ImageListHeader);
  DestroyProject(Wnd);
end;

function OnListViewCustomDraw(hDlg: HWND; uMsg: UINT; wParam: LongInt; lParam: LongInt): LRESULT;
var
  plvcd: PNMLVCUSTOMDRAW;
  R: TRect;
  Color: Cardinal;
  BkBrush, PrevBrush: HBRUSH;
  Ratio: array[0..MAX_PATH-1] of Char;
  iPercent: Integer;
begin
  Result := 0;
  plvcd := PNMLVCUSTOMDRAW(lParam);
  case plvcd.nmcd.dwDrawStage of

    CDDS_PREPAINT:
      Result := CDRF_NOTIFYITEMDRAW;

    CDDS_ITEMPREPAINT:
      begin
        //plvcd.clrText := GetSysColor(COLOR_WINDOWTEXT);
        //plvcd.clrTextBk := GetSysColor(COLOR_WINDOW);
        Result := CDRF_NOTIFYSUBITEMDRAW;
      end;

    CDDS_ITEMPREPAINT or CDDS_SUBITEM:
      begin

        Result := CDRF_DODEFAULT;

        if plvcd.iSubItem = SortColumn then
          plvcd.clrTextBk := RGB(247, 247, 247)//GetSysColor(COLOR_BTNFACE)
        else
          plvcd.clrTextBk := GetSysColor(COLOR_WINDOW);

        case plvcd.iSubItem of
          COLUMN_RATIO:
            begin
              //Folder := FileList[plvcd.nmcd.dwItemSpec];

              ListView_GetSubItemRect(hwndLV, plvcd.nmcd.dwItemSpec,
                plvcd.iSubItem, LVIR_LABEL, @R);

              if (plvcd.nmcd.uItemState and CDIS_SELECTED <> 0) then
              begin
                Color := GetSysColor(COLOR_HIGHLIGHT);
                SetTextColor(plvcd.nmcd.hdc, GetSysColor(COLOR_WINDOW));
              end
              else begin
                //Color := GetSysColor(COLOR_WINDOW);//plvcd.clrTextBk;
                Color := plvcd.clrTextBk;
                SetTextColor(plvcd.nmcd.hdc, GetSysColor(COLOR_WINDOWTEXT));
              end;

              BkBrush := CreateSolidBrush(Color);
              FillRect(plvcd.nmcd.hdc, R, BkBrush);

              FillChar(Ratio, SizeOf(Ratio), #0);

              ListView_GetItemText(hwndLV, plvcd.nmcd.dwItemSpec,
                plvcd.iSubItem, Ratio, SizeOf(Ratio));

              PrevBrush := SelectObject(plvcd.nmcd.hdc, BkBrush);
              InflateRect(R, -2, -2);
              InflateRect(R, -12, 0);
              OffsetRect(R, -12, 0);
              SelectObject(plvcd.nmcd.hdc, PrevBrush);
              Rectangle(plvcd.nmcd.hdc, R.Left, R.Top, R.Right, R.Bottom);
              DeleteObject(BkBrush);
              if StrScan(Ratio, '%') <> nil then
                StrLCopy(Ratio, Ratio, StrScan(Ratio, '%') - Ratio)
              else Ratio := '-1';
              try
                iPercent := StrToInt(Ratio);
              except
                iPercent := 0;
              end;
              if (iPercent < 0) or (iPercent > 100) then iPercent := 0;
              iPercent := Round((iPercent * (R.Right-R.Left)) / 100);
              R.Right := R.Left + iPercent;
              InflateRect(R, -1, -1);

              if (plvcd.nmcd.uItemState and CDIS_SELECTED <> 0) then
                BkBrush := CreateSolidBrush(GetSysColor(COLOR_BTNFACE))
              else
                BkBrush := CreateSolidBrush(GetSysColor(COLOR_INACTIVECAPTION));

              if R.Right > R.Left then FillRect(plvcd.nmcd.hdc, R, BkBrush);

              ListView_GetItemText(hwndLV, plvcd.nmcd.dwItemSpec,
                plvcd.iSubItem, Ratio, SizeOf(Ratio));

              ListView_GetSubItemRect(hwndLV, plvcd.nmcd.dwItemSpec,
                plvcd.iSubItem, LVIR_LABEL, @R);

              R.Left := R.Right - 24;

              DrawText(plvcd.nmcd.hdc, Ratio, lstrlen(Ratio),
                R, DT_END_ELLIPSIS or DT_SINGLELINE or DT_NOPREFIX or DT_VCENTER);

              {ImageList_Draw(ImageListSmall, Folder.FIcon,
                plvcd.nmcd.hdc, R.left, R.Top, ILD_TRANSPARENT);}

              DeleteObject(BkBrush);

              Result := CDRF_SKIPDEFAULT;

            end;
        end;
      end;
  end;
end;

function OnListViewGetDispInfo(hDlg: HWND; uMsg: UINT; wParam: LongInt; lParam: LongInt): LRESULT;
var
  pnmv: PLVDISPINFO;
  ArchiveFile: TArchiveFileItem;
  StateText: string;
begin

  Result := 0;

  pnmv := PLVDISPINFO(lParam);

  with pnmv^ do
  begin

    if (item.iItem < 0) or (item.iItem > Archive.Count) then Exit;

    ArchiveFile := TArchiveFileItem(Archive[item.iItem]);

    StateText := Format('%X', [item.state and $00FF]);
    {
    if item.mask and LVIF_STATE <> 0 then
    begin
      StateText := Format('%X', [item.stateMask]);
      if item.stateMask and LVIS_SELECTED <> 0 then
      begin
        //ListView_SetItemState(hwndLV, item.iItem, LVIS_SELECTED, LVIS_STATEIMAGEMASK);
        item.state := LVIS_SELECTED;
      end
      else begin
        item.stateMask := UINT(-1);
        item.state := LVIS_FOCUSED;
      end;
      //item.state := item.state; ///???? LVIS_SELECTED;//
    end;
    }
    if item.mask and LVIF_IMAGE <> 0 then
      item.iImage := ArchiveFile.Image;

    if item.mask and LVIF_TEXT <> 0 then
    case item.iSubItem of
      COLUMN_NAME:
        lstrcpy(item.pszText, PChar(ArchiveFile.FileName));
        //lstrcpy(item.pszText, PChar(StateText));
      COLUMN_TYPE:
        lstrcpy(item.pszText, PChar(ArchiveFile.FileType));
      COLUMN_MODIFIED:
        lstrcpy(item.pszText, PChar(ArchiveFile.DateTimeAsString));
      COLUMN_SIZE:
        lstrcpy(item.pszText, PChar(ArchiveFile.SizeAsString));
      COLUMN_RATIO:
        lstrcpy(item.pszText, PChar(ArchiveFile.RatioAsString));
      COLUMN_PACKED:
        lstrcpy(item.pszText, PChar(ArchiveFile.PackedSizeAsString));
      COLUMN_ATTR:
        lstrcpy(item.pszText, PChar(ArchiveFile.AttributeAsString));
      COLUMN_CRC32:
        lstrcpy(item.pszText, PChar(ArchiveFile.CRC32AsString));
      COLUMN_PATH:
        lstrcpy(item.pszText, PChar(ArchiveFile.Path));
    end;

  end;

end;

procedure ListViewSortBy(Column: Integer);
begin
  ClearSortBitmap( SortColumn );
  if Column = SortColumn then
    SortAscending := not SortAscending
  else SortAscending := True;
  SortColumn := Column;
  Archive.FileList.Sort(@ListSortCompare);
  ChangeSortBitmap( Column, SortAscending );
  InvalidateRect(hwndLV, nil, True);
end;

function OnListViewColumnClick(hDlg: HWND; uMsg: UINT; wParam: LongInt; lParam: LongInt): LRESULT;
var
  pnmv: PNMLISTVIEW;
begin
  Result := 0;
  pnmv := PNMLISTVIEW(lParam);
  ListViewSortBy( pnmv^.iSubItem );
end;

const
  strTipFormat =
    'File Name: %s'#13#10 +
    'Type: %s'#13#10 +
    'Modified: %s'#13#10 +
    'Size: %s bytes'#13#10 +
    'Ratio: %s'#13#10 +
    'Packed: %s bytes'#13#10 +
    'Attributes: %s'#13#10 +
    'CRC32: %s'#13#10 +
    'Path: %s';
var
  szTipBuffer: array[0..INFOTIPSIZE] of Char;

function OnListViewGetInfoTip(hDlg: HWND; uMsg: UINT; wParam: LongInt; lParam: LongInt): LRESULT;
var
  pGetInfoTip: PNMLVGETINFOTIP;
  strText: string;
  ArchiveFile: TArchiveFileItem;
begin
  Result := 0;
  pGetInfoTip := PNMLVGETINFOTIP(lParam);
  if ( pGetInfoTip.iItem < 0 ) or
     ( pGetInfoTip.iItem > Archive.Count ) then Exit;
  ArchiveFile := TArchiveFileItem( Archive[pGetInfoTip.iItem] );
  with ArchiveFile do
    strText := Format( strTipFormat,
      [FileName, FileType, DateTimeAsString, SizeAsString, RatioAsString,
      PackedSizeAsString, AttributeAsString, CRC32AsString, Path] );
  FillChar( szTipBuffer, SizeOf(szTipBuffer), 0 );
  StrCopy( szTipBuffer, PChar(strText) );
  pGetInfoTip.pszText := szTipBuffer;
  pGetInfoTip.cchTextMax := SizeOf(szTipBuffer);
end;

// Double-Click veya Return tusu durumunda olusuyor.
function OnListViewItemActivate(hDlg: HWND; uMsg: UINT; wParam: LongInt; lParam: LongInt): LRESULT;
var
  lpnmia: PNMITEMACTIVATE;
  Text: string;
  nSelected: Integer;
  Dialog: TPropertiesDialog;
begin
  Result := 0;
  lpnmia := PNMITEMACTIVATE(lParam);
  nSelected := ListView_GetSelectedCount(hwndLV);
  Text := Format('Selected %d files, %d bytes', [nSelected, 0]);
  if lpnmia.uKeyFlags = 0 then;
  //SendMessage(hwndSB, SB_SETTEXT, 0, LongInt(PChar(Text)));
  Dialog := TPropertiesDialog.Create( hDlg );
  try
    Dialog.ShowModal;
  finally
    Dialog.Free;
  end;

end;

var
  g_bRange: Boolean = False;

function OnListViewODStateChange(hDlg: HWND; uMsg: UINT; wParam: LongInt; lParam: LongInt): LRESULT;
var
  lpStateChange: PNMLVODSTATECHANGE;
  Text: string;
  Index: Integer;
  ArchiveFile: TArchiveFileItem;
  dwTotal: DWORD;
  nSelected: Integer;
  uTo: UINT;
begin
  Result := 0;
  lpStateChange := PNMLVODSTATECHANGE(lParam);
  with lpStateChange^ do begin
    dwTotal := 0;
    g_bRange := True;
    uTo := iTo;
    nSelected := ListView_GetSelectedCount(hwndLV);
    if iTo - iFrom + 1 > nSelected then Dec(uTo);
    for Index := iFrom to uTo do begin
      ArchiveFile := TArchiveFileItem(Archive[Index]);
      if uNewState and LVIS_SELECTED <> 0 then begin
        dwTotal := dwTotal + ArchiveFile.Size;
      end
      else if uOldState and LVIS_SELECTED <> 0 then begin
        dwTotal := dwTotal - ArchiveFile.Size;
      end;
    end;
    {
    Text := Format('Select Range From %d to %d, Total: %s', [iFrom, iTo,
      FormatByteSize(dwTotal)]);
    }
    Text := Format('Selected %d files, %s', [nSelected,//iTo - iFrom + 1,
      FormatByteSize(dwTotal)]);
    SendMessage(hwndSB, SB_SETTEXT, 0, LongInt(PChar(Text)));
  end;
  with lpStateChange^ do
    Text := Format('ODStateChange = uNewState: %d; uOldState: %d',
      [uNewState, uOldState]);
  OutputDebugString(PChar(Text));
end;

function OnListViewItemChanged(hDlg: HWND; uMsg: UINT; wParam: LongInt; lParam: LongInt): LRESULT;
var
  lpListView: PNMLISTVIEW;
  Text: string;
  nSelected: Integer;
  //iSelected: Integer;
  ArchiveFile: TArchiveFileItem;
begin
  Result := 0;
  lpListView := PNMLISTVIEW(lParam);
  with lpListView^ do begin
     if iItem = -1 then begin
       g_dwTotal := 0;
       g_bRange := False;
     end
     else begin
       if uChanged and LVIF_STATE <> 0 then begin
         ArchiveFile := TArchiveFileItem(Archive[iItem]);
         if uNewState and LVIS_SELECTED <> 0 then begin
           g_dwTotal := g_dwTotal + ArchiveFile.Size;
         end
         else if uOldState and LVIS_SELECTED <> 0 then begin
           g_dwTotal := g_dwTotal - ArchiveFile.Size;
         end;
       end;
     end;
     if not g_bRange then
     begin
       nSelected := ListView_GetSelectedCount(hwndLV);
       if nSelected > 0 then
         Text := Format('Selected %d files, %s', [nSelected, FormatByteSize(g_dwTotal)])
       else Text := 'No Files Selected';
       SendMessage(hwndSB, SB_SETTEXT, 0, LongInt(PChar(Text)));
     end;
  end;
  with lpListView^ do
    Text := Format('Item Changed = iItem: %d; uNewState: %d; uOldState: %d; uChanged: %d',
      [iItem, uNewState, uOldState, uChanged]);
  OutputDebugString(PChar(Text));
  {
  if lpListView^.uChanged and LVIF_STATE <> 0 then begin
    if lpListView^.uNewState and LVIS_SELECTED <> 0 then;
  end;
  with lpListView^ do
    Text := Format('iItem: %d; uNewState: %d; uOldState: %d; uChanged: %d',
      [iItem, uNewState, uOldState, uChanged]);
  OutputDebugString(PChar(Text));
  nSelected := ListView_GetSelectedCount(hwndLV);
  iSelected := ListView_GetNextItem(hwndLV, -1, LVNI_ALL or LVNI_SELECTED);
  if iSelected > -1 then begin
    Text := Format('Selected %d files, %d bytes', [nSelected, 0]);
    SendMessage(hwndSB, SB_SETTEXT, 0, LongInt(PChar(Text)));
  end;
  }
end;

function OnListViewNotify(hDlg: HWND; uMsg: UINT; wParam: LongInt; lParam: LongInt): LRESULT;
var
  pnmv: PNMLISTVIEW;
begin
  Result := 0;
  pnmv := PNMLISTVIEW(lParam);
  case pnmv^.hdr.code of
    LVN_ODSTATECHANGED:
      Result := OnListViewODStateChange(hDlg, uMsg, wParam, lParam);
    LVN_ITEMACTIVATE:
      Result := OnListViewItemActivate(hDlg, uMsg, wParam, lParam);
    LVN_COLUMNCLICK:
      Result := OnListViewColumnClick(hDlg, uMsg, wParam, lParam);
    NM_CUSTOMDRAW:
      Result := OnListViewCustomDraw(hDlg, uMsg, wParam, lParam);
    NM_RCLICK:;
      //Result := OnListViewRClick(hDlg, uMsg, wParam, lParam);
    LVN_DELETEALLITEMS:;
      //Result := OnListViewDeleteAllItems(hDlg, uMsg, wParam, lParam);
    LVN_DELETEITEM:;
      //Result := OnListViewDeleteItem(hDlg, uMsg, wParam, lParam);
    LVN_ITEMCHANGED:
      Result := OnListViewItemChanged(hDlg, uMsg, wParam, lParam);
    LVN_GETDISPINFO:
      Result := OnListViewGetDispInfo(hDlg, uMsg, wParam, lParam);
    LVN_GETINFOTIP:
      Result := OnListViewGetInfoTip(hDlg, uMsg, wParam, lParam);
  end;
end;

function OnListViewNeedText(hDlg: HWND; uMsg: UINT; wParam: LongInt; lParam: LongInt): LRESULT;
var
  lvhti: tagLVHITTESTINFO;
  strText: string;
  ArchiveFile: TArchiveFileitem;
begin
  Result := 0;
  GetCursorPos( lvhti.pt );
  ScreenToClient( hwndLV, lvhti.pt );
  ListView_HitTest( hwndLV, lvhti );
  if lvhti.flags and LVHT_ONITEM <> 0 then
  begin
    if ( lvhti.iItem < 0 ) or
       ( lvhti.iItem > Archive.Count ) then Exit;
    ArchiveFile := TArchiveFileItem( Archive[lvhti.iItem] );
    with ArchiveFile do
    strText := Format( strTipFormat,
      [FileName, FileType, DateTimeAsString, SizeAsString, RatioAsString,
       PackedSizeAsString, AttributeAsString, CRC32AsString, Path] );
    FillChar( szTipBuffer, SizeOf(szTipBuffer), 0 );
    StrCopy( szTipBuffer, PChar(strText) );
    Result := LRESULT(True);
  end;
end;

function OnToolTipNeedText(hDlg: HWND; uMsg: UINT; wParam: LongInt; lParam: LongInt): LRESULT;
var
  lpnmtdi: PNMTTDISPINFO;
begin
  Result := 0;
  lpnmtdi := PNMTTDISPINFO(lParam);
  if ( lpnmtdi.hdr.idFrom = hwndLV ) then
  begin
    if OnListViewNeedText( hDlg, uMsg, wParam, lParam ) = LRESULT(True) then
    begin
      SendMessage( lpnmtdi.hdr.hwndFrom, TTM_SETMAXTIPWIDTH, 0, 300 );
      lpnmtdi.lpszText := @szTipBuffer;
      //SetLayeredWindowAttributes( lpnmtdi.hdr.hwndFrom, 0, 240, LWA_ALPHA );
    end;
  end;
end;

const
  sFileName = 'File Name : ';
  sFileType = 'Type : ';
  sModified = 'Modified : ';

function OnToolTipCustomDraw(hDlg: HWND; uMsg: UINT; wParam: LongInt; lParam: LongInt): LRESULT;
var
  lpNMCustomDraw: PNMTTCUSTOMDRAW;
  R: TRect;
  brshBack, brshPrev, brshHead: HBRUSH;
  pinfo: tagLVHITTESTINFO;
  Item: Integer;
  ArchiveFile: TArchiveFileitem;
  CxIcon, CyIcon: Integer;
  hfontPrev: HFONT;
  TextSize: tagSIZE;
begin
  Result := 0;
  lpNMCustomDraw := PNMTTCUSTOMDRAW(lParam);
  with lpNMCustomDraw^.nmcd do
  begin
    case dwDrawStage of
      CDDS_PREPAINT:
        begin
          CxIcon := GetSystemMetrics(SM_CXICON);
          CyIcon := GetSystemMetrics(SM_CYICON);
          rc.Right  := rc.Right  + 2 * CxIcon;
          rc.Bottom := rc.Bottom + 2 * CyIcon;
          R := rc;
          InflateRect( R, 4, 4 );
          SetBkMode( hdc, TRANSPARENT );
          brshBack := CreateSolidBrush( GetSysColor(COLOR_INFOBK) );//RGB(240, 249, 255) );//
          brshPrev := SelectObject( hdc, brshBack );
          FillRect( hdc, R, brshBack );
          {
          R.Left := 0;
          R.Top := 0;
          R.Right := rc.Right;
          R.Bottom := CyIcon + 6;
          }
          brshHead := CreateSolidBrush( RGB(0, 152, 225) );//$00FFF9F0 ); 
          SetRect( R, 0, 0, rc.Right, CyIcon + 6 );
          FillRect( hdc, R, brshHead );
          DeleteObject( brshHead );

          R := rc;
          InflateRect( R, 4, 4 );

          MoveToEx(hdc, 0, CyIcon + 6, nil);
          LineTo(hdc, rc.Right, CyIcon + 6);
          R.Left := 8;
          R.Top := R.Top + CyIcon + 16;
          SetTextColor( hdc, RGB(128, 0, 0) );
          {
          DrawText(hdc, szTipBuffer, lstrlen(szTipBuffer), R,
            lpNMCustomDraw^.uDrawFlags );
          }
          {
          SetRect(R, 4, CyIcon + 8, CxIcon + 8 + 4, 2 * CyIcon + 8);
          Pie(hdc, R.Left, R.Top, R.Right,
            R.Bottom, 0, 10, 0, 10);
          }
          FillChar( pinfo, SizeOf(pinfo), 0 );
          GetCursorPos( pinfo.pt );
          ScreenToClient( hWndLV, pinfo.pt );
          pinfo.flags := LVHT_ONITEM;
          Item := ListView_HitTest( hWndLV, pinfo );
          if Item > -1 then begin
            R := rc;
            ArchiveFile := TArchiveFileItem( Archive[Item] );
            ImageList_Draw( ImageListLarge, ArchiveFile.Image,
              hdc, R.Left + 2, R.Top + 2, ILD_TRANSPARENT );
            R.Left := CxIcon + 12;
            R.Top := 4;
            R.Right := rc.Right - 2 * CxIcon - 2;
            R.Bottom := R.Top + CyIcon - 2;
            hfontPrev := SelectObject( hdc, g_hfTipCaption );
            SetTextColor( hdc, RGB(255, 255, 255) );
            DrawText( hdc, PChar(ArchiveFile.FileName),
              lstrlen(PChar(ArchiveFile.FileName)), R,
              DT_NOPREFIX or DT_SINGLELINE or DT_VCENTER );

            R.Left := 8;
            R.Top := CyIcon + 4;
            R.Right := rc.Right;
            R.Bottom := R.Top + CyIcon - 2;
            SetTextColor( hdc, RGB(0, 128, 0) );
            DrawText( hdc, PChar(sFileType), lstrlen(sFileType), R,
              DT_NOPREFIX or DT_SINGLELINE or DT_VCENTER );

            GetTextExtentPoint32( hdc, PChar(sFileType), lstrlen(sFileType),
              TextSize );

            OffsetRect( R, 0, TextSize.cy );
            SetTextColor( hdc, RGB(0, 0, 128) );
            DrawText( hdc, PChar(sModified), lstrlen(sModified), R,
              DT_NOPREFIX or DT_SINGLELINE or DT_VCENTER );

            OffsetRect( R, 0, 2 * TextSize.cy );
            //Rectangle( hdc, R.Left, R.Top, R.Left + 80, R.Top + 16 );
            SetTextColor( hdc, RGB(240, 0, 0) );
            DrawText( hdc, PChar(g_strTime), lstrlen(PChar(g_strTime)), R,
              DT_NOPREFIX or DT_SINGLELINE or DT_VCENTER );

            SelectObject( hdc, hfontPrev );

            R.Left := R.Left + TextSize.cx;
            R.Top := CyIcon + 4;
            R.Right := rc.Right;
            R.Bottom := R.Top + CyIcon - 2;
            SetTextColor( hdc, RGB(0, 0, 0) );
            DrawText( hdc, PChar(ArchiveFile.FileType),
              lstrlen(PChar(ArchiveFile.FileType)), R,
              DT_NOPREFIX or DT_SINGLELINE or DT_VCENTER );

          end;

          SelectObject( hdc, brshPrev );
          DeleteObject( brshBack );

          Result := CDRF_SKIPDEFAULT;
        end;
    end;
  end;
end;

function OnToolTipShow(hDlg: HWND; uMsg: UINT; wParam: LongInt; lParam: LongInt): LRESULT;
begin
  Result := 0;
  SetTimer( hDlg, IDC_TIMER, 1000, nil );
  g_bToolTipActive := True;
end;

function OnToolTipPop(hDlg: HWND; uMsg: UINT; wParam: LongInt; lParam: LongInt): LRESULT;
begin
  Result := 0;
  KillTimer( hDlg, IDC_TIMER );
  g_bToolTipActive := False;
end;

function OnToolTipNotify(hDlg: HWND; uMsg: UINT; wParam: LongInt; lParam: LongInt): LRESULT;
var
  pnmv: PNMLISTVIEW;
begin
  Result := 0;
  pnmv := PNMLISTVIEW(lParam);
  case pnmv^.hdr.code of
    NM_CUSTOMDRAW:
      Result := OnToolTipCustomDraw(hDlg, uMsg, wParam, lParam);
    TTN_NEEDTEXT:
      Result := OnToolTipNeedText(hDlg, uMsg, wParam, lParam);
    TTN_SHOW:
      Result := OnToolTipShow(hDlg, uMsg, wParam, lParam);
    TTN_POP:
      Result := OnToolTipPop(hDlg, uMsg, wParam, lParam);
  end;
end;

function OnNotify(hDlg: HWND; uMsg: UINT; wParam: LongInt; lParam: LongInt): LRESULT;
var
  pnmh: PNMHDR;
begin
  Result := 0;
  pnmh := PNMHDR(lParam);
  {
  case pnmh^.code of
    TTN_NEEDTEXT:
      OnNeedText( hDlg, uMsg, wParam, lParam );
    NM_CUSTOMDRAW:
      Exit;
  end;
  }
  if pnmh^.hwndFrom = hWndTT then
    Result := OnToolTipNotify(hDlg, uMsg, wParam, lParam)
  else if pnmh^.hwndFrom = hWndLV then
    Result := OnListViewNotify(hDlg, uMsg, wParam, lParam);
  {
  case pnmh^.idFrom of
    IDC_LISTVIEW:
      Result := OnListViewNotify(hDlg, uMsg, wParam, lParam);
    IDC_TOOLTIP:
      Result := OnToolTipNotify(hDlg, uMsg, wParam, lParam);
  end;
  }
end;

procedure GetClientView(Wnd: HWND; var R: TRect);
var
  Rt, Rs: TRect;
begin
  GetClientRect(Wnd, R);
  GetWindowRect(hWndRB, Rt);
  GetWindowRect(hWndSB, Rs);
  R.Top := R.Top + (Rt.Bottom - Rt.Top);
  R.Bottom := R.Bottom - (Rs.Bottom - Rs.Top);
end;

function EnumFunc(hWndChild: HWND; lParam: LongInt): BOOL stdcall;
var
  R: PRect;
  CR: TRect;
begin
  R := PRect(lParam);
  if hWndChild = hWndRB then
  begin
    GetWindowRect(hWndChild, CR);
    MoveWindow(hWndChild, 0, 0, (R^.Right-R^.Left), CR.Bottom-CR.Top, True);
  end
  else if hWndChild = hWndSB then
  begin
    GetWindowRect(hWndChild, CR);
    MoveWindow(hWndChild, R^.Left, R^.Bottom - (CR.Bottom - CR.Top),
      (R^.Right - R^.Left), CR.Bottom - CR.Top, True);
  end
  else if hWndChild = hWndLV then
  begin
    GetClientView(GetParent(hWndChild), CR);
    MoveWindow(hWndChild, CR.Left, CR.Top, CR.Right - CR.Left,
      CR.Bottom - CR.Top, True);
    InvalidateRect(hWndChild, nil, True);
  end;
  Result := True;
end;

{ OnSize }
function OnSize(Wnd: HWND; uMsg: UINT; wParam: LongInt; lParam: LongInt): LRESULT;
var
  ClientRect: TRect;
begin
  Result := 0;
  GetClientRect(Wnd, ClientRect);
  EnumChildWindows(Wnd, @EnumFunc, LongInt(@ClientRect));
end;

{ OnClose }
function OnClose(Wnd: HWND; uMsg: UINT; wParam: LongInt; lParam: LongInt): LRESULT;
begin
  Result := 0;
end;

{ OnMouseMove }
function OnMouseMove(Wnd: HWND; uMsg: UINT; wParam: LongInt; lParam: LongInt): LRESULT;
begin
  Result := 0;
end;

{ OnLButtonDown }
function OnLButtonDown(Wnd: HWND; uMsg: UINT; wParam: LongInt; lParam: LongInt): LRESULT;
begin
  Result := 0;
end;

{ OnLButtonUp }
function OnLButtonUp(Wnd: HWND; uMsg: UINT; wParam: LongInt; lParam: LongInt): LRESULT;
begin
  Result := 0;
end;

{ OnOpenFile }
function OnOpenFile(Wnd: HWND; uMsg: UINT; wParam: LongInt; lParam: LongInt): LRESULT;
begin
  Result := LRESULT(True);
  if OpenFileDialog(Wnd, '', ProjectName) then
  begin
    ProjectActive := OpenProject( Wnd, ProjectName );
    if not ProjectActive then
      MessageBox(Wnd, PChar(ProjectName), 'Open File', MB_ICONINFORMATION);
  end;
end;

{ OnCloseFile }
function OnCloseFile(Wnd: HWND; uMsg: UINT; wParam: LongInt; lParam: LongInt): LRESULT;
begin
  Result := LRESULT(True);
  CloseProject(Wnd);
  ProjectActive := False;
end;

{ OnExtractFile }
function OnExtractFile(Wnd: HWND; uMsg: UINT; wParam: LongInt; lParam: LongInt): LRESULT;
var
  //Index: Integer;
  strDest: string;
begin
  Result := LRESULT(True);
  if not ProjectActive then Exit;
  if SelectDirectory( Wnd, 'Select Destination Folder', '', strDest ) then
  begin
    Archive.ExtractAll(strDest);
    SendMessage(hwndSB, SB_SETTEXT, 1,
      LongInt(PChar('Archive: ' + ExtractFileName(ProjectName))));
  end;
end;

procedure ShowAboutDialog(hwndParent: HWND);
var
  About: CAboutDialog;
begin
  About := CAboutDialog.Create( hwndParent, 220 );
  try
    About.ShowModal;
  finally
    About.Free;
  end;
end;

{ OnCommand }
function OnCommand(Wnd: HWND; uMsg: UINT; wParam: LongInt; lParam: LongInt): LRESULT;
begin
  Result := LRESULT(True);
  case LOWORD(wParam) of
    IDM_OPEN:
      Result := OnOpenFile(Wnd, uMsg, wParam, lParam);
    IDM_CLOSE:
      Result := OnCloseFile(Wnd, uMsg, wParam, lParam);
    IDM_EXTRACT:
      Result := OnExtractFile(Wnd, uMsg, wParam, lParam);
    IDM_EXIT:
      SendMessage(Wnd, WM_CLOSE, 0, 0);
    IDM_LARGEICONS:
      SetViewStyle( hwndLV, LVS_ICON );
    IDM_SMALLICONS:
      SetViewStyle( hwndLV, LVS_SMALLICON );
    IDM_LISTVIEW:
      SetViewStyle( hwndLV, LVS_LIST );
    IDM_REPORTVIEW:
      SetViewStyle( hwndLV, LVS_REPORT );
    IDM_BYNAME,
    IDM_BYTYPE,
    IDM_BYMODIFIED,
    IDM_BYSIZE,
    IDM_BYRATIO,
    IDM_BYPACKED,
    IDM_BYCRC32,
    IDM_BYATTR,
    IDM_BYPATH:
      ListViewSortBy( LOWORD(wParam)-40010 );

    IDM_ABOUT:
      ShowAboutDialog( Wnd );
  end;
end;

{ OnAddItemEvent }
function OnAddItemEvent(Wnd: HWND; uMsg: UINT; wParam: LongInt; lParam: LongInt): LRESULT;
begin
  Result := LRESULT(False);
  hcrCurrent := SetCursor(hcrWait);
  SetCursor(hcrCurrent);
end;

{ OnAddExtractEvent }
function OnAddExtractEvent(Wnd: HWND; uMsg: UINT; wParam: LongInt; lParam: LongInt): LRESULT;
begin
  Result := LRESULT(False);
  hcrCurrent := SetCursor(hcrWait);
  SetCursor(hcrCurrent);
end;

{ OnTimer }
function OnTimer(Wnd: HWND; uMsg: UINT; wParam: LongInt; lParam: LongInt): LRESULT;
begin
  Result := 0;
  if wParam = IDC_TIMER then begin
    if g_bToolTipActive then begin
      g_strTime := TimeToStr(Time);
      SendMessage( hWndTT, TTM_UPDATE, 0, 0 );
    end;
  end;
end;

function MainWndProc(Wnd: HWND; uMsg: UINT; wParam: LongInt; lParam: LongInt): LRESULT; stdcall;
begin

  Result := 0;

  case uMsg of

    WM_TIMER:
      Result := OnTimer(Wnd, uMsg, wParam, lParam);

    CM_ADDITEMEVENT:
      Result := OnAddItemEvent(Wnd, uMsg, wParam, lParam);

    CM_EXTRACTITEMEVENT:
      Result := OnAddExtractEvent(Wnd, uMsg, wParam, lParam);

    WM_COMMAND:
      Result := OnCommand(Wnd, uMsg, wParam, lParam);

    WM_NOTIFY:
      Result := OnNotify(Wnd, uMsg, wParam, lParam);

    WM_LBUTTONDOWN:
      Result := OnLButtonDown(Wnd, uMsg, wParam, lParam);

    WM_LBUTTONUP:
      Result := OnLButtonUp(Wnd, uMsg, wParam, lParam);

    WM_MOUSEMOVE:
      Result := OnMouseMove(Wnd, uMsg, wParam, lParam);

    WM_SIZE:
      Result := OnSize(Wnd, uMsg, wParam, lParam);

    WM_CREATE:
      OnCreate(Wnd, uMsg, wParam, lParam);

    WM_DESTROY:
      begin
        Result := OnDestroy(Wnd, uMsg, wParam, lParam);
        PostQuitMessage(0);
      end;

    WM_CLOSE:
      begin
        Result := OnClose(Wnd, uMsg, wParam, lParam);
        DestroyWindow(Wnd);
      end;

  else
    Result := DefWindowProc(Wnd, uMsg, wParam, lParam);
  end;

end;

function InitInstance(hInst: LongWord): BOOL;
var
  WndClass: WNDCLASSEX;
begin

  with WndClass do
  begin
    WndClass.cbSize := SizeOf(WNDCLASSEX);
    style := CS_DBLCLKS;
    lpfnWndProc := @MainWndProc;
    cbClsExtra := 0;
    cbWndExtra := 0;
    hInstance := hInst;
    hIcon := LoadIcon(hInst, MAKEINTRESOURCE(IDI_MAINICON));
    hCursor := LoadCursor(0, IDC_SIZEWE);
    hbrBackground := GetStockObject( NULL_BRUSH );
    lpszMenuName := MAKEINTRESOURCE(IDM_MAINMENU);
    lpszClassName := szClassName;
    hIconSm := LoadImage(hInst, MakeIntResource(IDI_MAINICON), IMAGE_ICON,
      GetSystemMetrics(SM_CXSMICON), GetSystemMetrics(SM_CYSMICON),
      LR_DEFAULTCOLOR);
  end;

  Result := RegisterClassEx(WndClass) <> 0;

end;

function InitApplication(hInst: LongWord; nCmdShow: Integer): BOOL;
begin

  hwndMain := CreateWindowEx(
    0,
    szClassName,
    szCaption,
    WS_OVERLAPPEDWINDOW,
    Integer(CW_USEDEFAULT), Integer(CW_USEDEFAULT),
    Integer(CW_USEDEFAULT), Integer(CW_USEDEFAULT),
    0,
    0,
    hInst,
    nil);

  Result := hWndMain <> 0;

  if Result then
  begin
    ShowWindow(hWndMain, nCmdShow);
    UpdateWindow(hWndmain);
  end;

end;

procedure WinMain(hInst: LongWord; hPrevInst: LongWord);
var
  Msg: TMSG;
begin

  InitCommonControls;

  CoInitialize(nil);

  if not InitInstance(hInst) then
    Halt;

  if not InitApplication(hInst, SW_SHOW) then
    Halt;

  Accel := LoadAccelerators(hInst, MAKEINTRESOURCE(IDA_MAINACCEL));

  while GetMessage(Msg, 0, 0, 0) do
  begin
    if TranslateAccelerator(hwndMain, Accel, Msg) = 0 then
    begin
      TranslateMessage(Msg);
      DispatchMessage(Msg);
    end;
  end;

  DestroyAcceleratorTable(Accel);

  CoUnInitialize();

  Halt(Msg.wParam);

end;

{ TEventNotify }

procedure TEventNotify.AddItemEvent(Sender: TCustomArchiveFile;
  Item: TArchiveFileItem);
var
  Text: string;
begin
  Text := 'Adding File: ' + Item.FileName;
  //SetWindowText(hwndMain, PChar(Text));
  SendMessage(hwndSB, SB_SETTEXT, 1, LongInt(PChar(Text)));
end;

constructor TEventNotify.Create(Archive: TArchiveFile);
begin
  FArchive := Archive;
  FArchive.OnAddItem := AddItemEvent;
  FArchive.OnExtractItem := ExtractItemEvent;
end;

destructor TEventNotify.Destroy;
begin
  inherited Destroy;
end;

procedure TEventNotify.ExtractItemEvent(Sender: TCustomArchiveFile;
  Item: TArchiveFileItem);
var
  Text: string;
begin
  Text := 'Extracting File: ' + Item.FileName;
  //SetWindowText(hwndMain, PChar(Text));
  SendMessage(hwndSB, SB_SETTEXT, 1, LongInt(PChar(Text)));
end;

{ TArchiveProject }

procedure TArchiveProject.AddItemEvent(Sender: TCustomArchiveFile;
  Item: TArchiveFileItem);
begin

end;

procedure TArchiveProject.Close;
begin

end;

constructor TArchiveProject.Create;
begin
  FArchive := nil;
  FArchiveName := '';
end;

destructor TArchiveProject.Destroy;
begin
  inherited Destroy;
end;

procedure TArchiveProject.ExtractItemEvent(Sender: TCustomArchiveFile;
  Item: TArchiveFileItem);
begin

end;

procedure TArchiveProject.Open(const ArchiveName: string);
begin

end;

procedure TArchiveProject.SetActive(Value: Boolean);
begin

end;

begin
  WinMain(hInstance, hPrevInst);
end.
