unit SystemGlobal;

interface

uses Windows, Messages, CommCtrl, ShlObj, ShellAPI, ActiveX, Classes, SysUtils,
  CommDlg, Shlwapi, ZLib, UnRAR;

var
  hwndMain: HWND;
  
const
  SC_DRAGMOVE = $F012;
  
  szClassName = 'ANS-GenericClass';
  szCaption   = 'Open Archive';
  IDI_MAINICON = 101;
  IDM_MAINMENU = 101;
  IDA_MAINACCEL = 101;

  IDC_TREEVIEW = 40001;
  IDC_LISTVIEW = 40002;
  IDC_REBAR    = 40003;
  IDC_TOOLBAR  = 40004;

const
  // Windows XP Style
  WS_EX_LAYERED = $00080000;
  LWA_COLORKEY  = $00000001;
  LWA_ALPHA     = $00000002;
  
  LVS_EX_DOUBLEBUFFER     = $00010000;
  LVS_EX_HIDELABELS       = $00020000;
  LVS_EX_SINGLEROW        = $00040000;
  LVS_EX_SNAPTOGRID       = $00080000;
  LVS_EX_SIMPLESELECT     = $00100000;

  TTS_BALLOON    =  $40;

{ SetLayeredWindowAttributes }
function SetLayeredWindowAttributes(Hwnd: THandle; crKey: COLORREF;
  bAlpha: Byte; dwFlags: DWORD): Boolean; stdcall;

{ SelectDirectory }
function SelectDirectory(Owner: HWND; const Caption: string; const Root: WideString;
  out Directory: string): Boolean;

{ OpenFileDialog }
function OpenFileDialog(WndDlg: HWND; const InitialDir: string;
 var FileName: string): BOOL;

implementation

const
  BIF_NEWDIALOGSTYLE  = $0040;
  BIF_USENEWUI	      = BIF_EDITBOX or BIF_NEWDIALOGSTYLE;

function SelectDirectory(Owner: HWND; const Caption: string; const Root: WideString;
  out Directory: string): Boolean;
var
  BrowseInfo: TBrowseInfo;
  Buffer: PChar;
  RootItemIDList, ItemIDList: PItemIDList;
  ShellMalloc: IMalloc;
  IDesktopFolder: IShellFolder;
  Eaten, Flags: LongWord;
begin
  Result := False;
  Directory := '';
  FillChar(BrowseInfo, SizeOf(BrowseInfo), 0);
  if (ShGetMalloc(ShellMalloc) = S_OK) and (ShellMalloc <> nil) then
  begin
    Buffer := ShellMalloc.Alloc(MAX_PATH);
    try
      SHGetDesktopFolder(IDesktopFolder);
      IDesktopFolder.ParseDisplayName(Owner, nil,
        POleStr(Root), Eaten, RootItemIDList, Flags);
      with BrowseInfo do
      begin
        hwndOwner := Owner;
        pidlRoot := RootItemIDList;
        pszDisplayName := Buffer;
        lpszTitle := PChar(Caption);
        ulFlags := BIF_RETURNONLYFSDIRS or BIF_USENEWUI;
      end;
      ItemIDList := SHBrowseForFolder(BrowseInfo);
      Result :=  ItemIDList <> nil;
      if Result then
      begin
        ShGetPathFromIDList(ItemIDList, Buffer);
        ShellMalloc.Free(ItemIDList);
        Directory := Buffer;
      end;
    finally
      ShellMalloc.Free(Buffer);
    end;
  end;
end;

{ OpenFileDialog }
function OpenFileDialog(WndDlg: HWND; const InitialDir: string; var FileName: string): BOOL;
const
  lpstrFilter = 'Zip Archives (*.zip)'#0'*.zip'#0 +
    'Rar Archives (*.rar)'#0'*.rar'#0 +
    'Cabinet Archives (*.cab)'#0'*.cab'#0 +
    'All Files (*.*)'#0'*.*'#0#0;
var
  OpenFile: OPENFILENAME;
  lpstrFile: array[0..MAX_PATH-1] of Char;
begin
  FillChar(OpenFile, SizeOf(OPENFILENAME), 0);
  FillChar(lpstrFile, SizeOf(lpstrFile), 0);
  OpenFile.lStructSize := SizeOf(OPENFILENAME);
  OpenFile.hWndOwner := WndDlg;
  OpenFile.hInstance := hInstance;
  OpenFile.lpstrFilter := lpstrFilter;
  OpenFile.lpstrFile := lpstrFile;
  OpenFile.nMaxFile := SizeOf(lpstrFile);
  OpenFile.lpstrInitialDir := PChar(InitialDir);
  OpenFile.Flags := OFN_HIDEREADONLY or OFN_NONETWORKBUTTON;
  Result := GetOpenFileName(OpenFile);
  if Result then
    SetString(FileName, lpstrFile, lstrlen(lpstrFile));
end;


const
  user32 = 'user32.dll';

{$EXTERNALSYM SetLayeredWindowAttributes}
function SetLayeredWindowAttributes(Hwnd: THandle; crKey: COLORREF;
  bAlpha: Byte; dwFlags: DWORD): Boolean; stdcall;
  external user32 name 'SetLayeredWindowAttributes';

end.
